leetcode 3567. 子矩阵的最小绝对差 中等

给你一个 m x n 的整数矩阵 grid 和一个整数 k。

对于矩阵 grid 中的每个连续的 k x k 子矩阵 ,计算其中任意两个 不同 值 之间的 最小绝对差。

返回一个大小为 (m - k + 1) x (n - k + 1) 的二维数组 ans,其中 ans[i][j] 表示以 grid 中坐标 (i, j) 为左上角的子矩阵的最小绝对差。

注意:如果子矩阵中的所有元素都相同,则答案为 0。

子矩阵 (x1, y1, x2, y2) 是一个由选择矩阵中所有满足 x1 <= x <= x2 且 y1 <= y <= y2 的单元格 matrix[x][y] 组成的矩阵。

示例 1:

输入: grid = \[1,8,3,-2], k = 2

输出: \[2]

解释:

  • 只有一个可能的 k x k 子矩阵:[[1, 8], [3, -2]]。
  • 子矩阵中的不同值为 [1, 8, 3, -2]。
  • 子矩阵中的最小绝对差为 |1 - 3| = 2。因此,答案为 [[2]]。

示例 2:

输入: grid = \[3,-1], k = 1

输出: \[0,0]

解释:

  • 每个 k x k 子矩阵中只有一个不同的元素。
  • 因此,答案为 [[0, 0]]。

示例 3:

输入: grid = \[1,-2,3,2,3,5], k = 2

输出: \[1,2]

解释:

  • 有两个可能的 k × k 子矩阵:
    • 以 (0, 0) 为起点的子矩阵:[[1, -2], [2, 3]]。
      • 子矩阵中的不同值为 [1, -2, 2, 3]。
      • 子矩阵中的最小绝对差为 |1 - 2| = 1。
    • 以 (0, 1) 为起点的子矩阵:[[-2, 3], [3, 5]]。
      • 子矩阵中的不同值为 [-2, 3, 5]。
      • 子矩阵中的最小绝对差为 |3 - 5| = 2。
  • 因此,答案为 [[1, 2]]。

提示:

  • 1 <= m == grid.length <= 30
  • 1 <= n == grid[i].length <= 30
  • -105 <= grid[i][j] <= 10^5
  • 1 <= k <= min(m, n)

分析:暴力枚举每一个子矩阵,求出其中不相等的值的最小绝对差。

cpp 复制代码
class Solution {
public:
    vector<vector<int>> minAbsDiff(vector<vector<int>>& grid, int k) {
        int m=grid.size(),n=grid[0].size();
        vector<vector<int>>ans;
        
        for(int i=0;i<=m-k;++i)
        {
            vector<int>temp;ans.push_back(temp);
            for(int j=0;j<=n-k;++j)
            {
                priority_queue<int,vector<int>,greater<>>pque;
                for(int x=i,t=0;t<k;++t,++x)
                    for(int y=j,l=0;l<k;++y,++l)
                        pque.push(grid[x][y]);

                int cnt=1000000,num=pque.top();pque.pop();
                while(!pque.empty())
                {
                    int val=pque.top();pque.pop();
                    if(num!=val)cnt=min(cnt,(int)abs(num-val));
                    num=val;
                }
                if(cnt==1000000)cnt=0;
                ans[i].push_back(cnt);
            }
        }

        return ans;
    }
};
相关推荐
longlongzihan9 小时前
链表找环:Floyd 判圈算法(LeetCode 141 & 142 )
c++·算法·leetcode·链表
yi01110 小时前
LeetCode 643. 子数组最大平均数 I|从暴力枚举到滑动窗口
人工智能·笔记·python·算法·leetcode·滑动窗口
java_nnnn11 小时前
LeetCode刷题双指针(有效三角形的个数+三数之和)Java
算法·leetcode·职场和发展
All for pursuit.13 小时前
【动态规划-6】96.不同的二叉搜索树
数据结构·c++·算法·leetcode·动态规划
All for pursuit.15 小时前
【并查集-2】399.除法求值
数据结构·c++·算法·leetcode
Nil20816 小时前
leetcode 416分割等和子集
算法·leetcode·职场和发展
y1su18 小时前
Leetcode 二分模板
java·数据结构·算法·leetcode·排序算法
Pniubi19 小时前
力扣55跳跃游戏(贪心)
算法·leetcode·游戏
CoderYanger21 小时前
A.每日一题:856. 括号的分数
java·程序人生·算法·leetcode·面试·职场和发展·学习方法
All for pursuit.1 天前
【动态规划-8】152.乘积最大子数组
数据结构·c++·算法·leetcode·动态规划